

stages:
  - build
  - upload
  - release

build:
  image: node:hydrogen
  stage: build
  script:
    - echo "Building extension version ..."
    - npm install
    - npm run package
    - npm run package.beta
  artifacts:
    paths:
      - artifacts/


upload:
  stage: upload
  image: curlimages/curl:latest
  script:
    - echo "Uploading assets ..."
    - |
      EXTENSION_VERSION=$(cat manifest.json | grep -o '"version": "[^"]*' | grep -o '[^"]*$')
      PACKAGE_REGISTRY_URL="${CI_API_V4_URL}/projects/${CI_PROJECT_ID}/packages/generic/crumbs-extension/${EXTENSION_VERSION}"
      for f in $(ls artifacts)
      do
        echo "Uploading file - $f"
        curl --header "JOB-TOKEN: ${CI_JOB_TOKEN}" --upload-file artifacts/${f} "${PACKAGE_REGISTRY_URL}/${f}"
      done


release:
  # Caution, as of 2021-02-02 these assets links require a login, see:
  # https://gitlab.com/gitlab-org/gitlab/-/issues/299384
  stage: release
  image: registry.gitlab.com/gitlab-org/release-cli:latest
  script:
    - |
      EXTENSION_VERSION=$(cat manifest.json | grep -o '"version": "[^"]*' | grep -o '[^"]*$')
      PACKAGE_REGISTRY_URL="${CI_API_V4_URL}/projects/${CI_PROJECT_ID}/packages/generic/crumbs-extension/${EXTENSION_VERSION}"
      release-cli create --name "$EXTENSION_VERSION" --tag-name $EXTENSION_VERSION \
        $(
          for f in $(ls artifacts)
          do
            echo "--assets-link" "{\"name\":\"${f}\",\"url\":\"${PACKAGE_REGISTRY_URL}/${f}\"}"
          done
        )